/*****************************************************************
 * FILE: pessimistic_optimistic.h
 *****************************************************************
 * Copyright 2005 by Dean Starrett, Travis Wheeler
 * University of Arizona
 * Department of Computer Science
 * Tucson, AZ  85721
 *****************************************************************
 * Terms of use:
 * This software may be used for non-commercial purposes.
 * Other use, redistribution, or modification may be done only 
 * with the author's prior approval. (contact twheeler@cs.arizona.edu)
 *
 * Released: @ALIGNALIGN_RELEASE_DATE@
 * Version:  @ALIGNALIGN_RELEASE_VERSION@
 * 
 ****************************************************************/
 
#ifndef PESSIMISTIC_OPTIMISTIC_H_
#define PESSIMISTIC_OPTIMISTIC_H_

#include "aa_globals.h"
#include "mem.h"
#include "spcost.h"


int pessimistic_optimistic_incl_alignment (char **A, char **B, 
			int k, int l, int m, int n, double r, char ***return_alignment, 
			int *return_len, unsigned char **script );
			
int pessimistic_optimistic_incl_alignment_unweighted (char **A, char **B, 
			int k, int l, int m, int n, double r, char ***return_alignment, 
			int *return_len, unsigned char **script );

int pessimistic_optimistic_incl_alignment_weighted (char **A, char **B, 
			int k, int l, int m, int n, double r, char ***return_alignment, 
			int *return_len, unsigned char **script );

int pessimistic_optimistic(char **A, char **B, 
				    int k, int l, int m, int n, double p);




int reverse_optimistic_table (char **A, char **B, int k, int l, int m, int n, 
		  int ***H, int ***V, int ***D) ;

int reverse_optimistic_table_unweighted (char **A, char **B, int k, int l, int m, int n, 
		  int ***H, int ***V, int ***D) ;

int reverse_optimistic_table_weighted (char **A, char **B, int k, int l, int m, int n, 
		  int ***H, int ***V, int ***D) ;

void calcCost ( int **H, int **V, int **D, 
			char **A, char **B, int endDirec, int i, int j, int k, int l, double r, 
			int *a, int *b, int *c, int *d );							

inline int minABC (int a, int b, int c) ;

#endif /*PESSIMISTIC_OPTIMISTIC_H_*/
